Index: src/Actions/ActionSequence.cpp
===================================================================
--- src/Actions/ActionSequence.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/ActionSequence.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -8,4 +8,6 @@
 #include "Actions/ActionSequence.hpp"
 #include "Actions/Action.hpp"
+
+#include "Helpers/Assert.hpp"
 
 using namespace std;
@@ -34,21 +36,80 @@
 }
 
+// this method is used outside the ActionModule
+// Each action registers itself with the history
 void ActionSequence::callAll(){
-  deque<Action*>::iterator it;
-  for(it=actions.begin(); it!=actions.end(); it++)
+  for(actionSet::iterator it=actions.begin(); it!=actions.end(); it++){
+    // we want to have a global bookkeeping for all actions in the sequence, so
+    // we bypass the normal call
     (*it)->call();
+  }
 }
 
-void ActionSequence::undoAll(){
-  deque<Action*>::reverse_iterator rit;
-  for(rit=actions.rbegin(); rit!=actions.rend(); rit++)
-    (*rit)->undo();
+// This method is used internally when MakroActions are constructed.
+// In this case only the makro Action should be registered and
+// handle the states
+ActionSequence::stateSet ActionSequence::callAll(bool){
+  stateSet states;
+  for(actionSet::iterator it=actions.begin(); it!=actions.end(); it++){
+    // we want to have a global bookkeeping for all actions in the sequence, so
+    // we bypass the normal call
+    Action::state_ptr state = (*it)->performCall();
+    states.push_back(state);
+  }
+  return states;
+}
+
+ActionSequence::stateSet ActionSequence::undoAll(stateSet states){
+  ASSERT(canUndo(),"Trying to undo a sequence that contains methods that can't be undone");
+  stateSet res;
+  actionSet::reverse_iterator actionRit = actions.rbegin();
+  stateSet::reverse_iterator stateRit = states.rbegin();
+  for(;actionRit!=actions.rend();++actionRit,++stateRit){
+    ASSERT(stateRit!=states.rend(),"End of states prematurely reached.");
+    if((*actionRit)->shouldUndo()){
+      Action::state_ptr newState = (*actionRit)->performUndo(*stateRit);
+      // The order of the states has to correspond to the order of the actions
+      // this is why we have to add at the beginning
+      res.push_front(newState);
+    }
+    else{
+      res.push_front(Action::success);
+    }
+  }
+  return res;
+}
+
+ActionSequence::stateSet ActionSequence::redoAll(stateSet states){
+  stateSet res;
+  actionSet::iterator actionIt = actions.begin();
+  stateSet::iterator stateIt = states.begin();
+  for(;actionIt!=actions.end();++actionIt,++stateIt){
+    ASSERT(stateIt!=states.end(),"End of states prematurely reached.");
+    if((*actionIt)->shouldUndo()){
+      Action::state_ptr newState =(*actionIt)->performRedo(*stateIt);
+      res.push_back(newState);
+    }
+    else{
+      res.push_back(Action::success);
+    }
+  }
+  return res;
 }
 
 bool ActionSequence::canUndo(){
   bool canUndo=true;
-  deque<Action*>::iterator it;
-  for(it=actions.begin(); it!=actions.end(); it++)
-    canUndo &= (*it)->canUndo();
+  for(deque<Action*>::iterator it=actions.begin(); it!=actions.end(); ++it){
+    if((*it)->shouldUndo()){
+      canUndo &= (*it)->canUndo();
+    }
+  }
   return canUndo;
 }
+
+bool ActionSequence::shouldUndo(){
+  bool shouldUndo = false;
+  for(deque<Action*>::iterator it=actions.begin();it!=actions.end();++it){
+    shouldUndo |= (*it)->shouldUndo();
+  }
+  return shouldUndo;
+}
Index: src/Actions/ActionSequence.hpp
===================================================================
--- src/Actions/ActionSequence.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/ActionSequence.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,7 +9,7 @@
 #define ACTIONSEQUENZE_HPP_
 
+#include "Actions/Action.hpp"
+
 #include <deque>
-
-class Action;
 
 /**
@@ -18,5 +18,9 @@
 class ActionSequence
 {
+  friend class MakroAction;
 public:
+  typedef std::deque<Action*> actionSet;
+  typedef std::deque<Action::state_ptr> stateSet;
+
   ActionSequence();
   virtual ~ActionSequence();
@@ -26,10 +30,14 @@
 
   void callAll();
-  void undoAll();
 
   bool canUndo();
+  bool shouldUndo();
 
+protected:
+  stateSet callAll(bool); // Dummy parameter to allow overloading
+  stateSet undoAll(stateSet);
+  stateSet redoAll(stateSet);
 private:
-  std::deque<Action*> actions;
+  actionSet actions;
 };
 
Index: src/Actions/AtomsCalculation.hpp
===================================================================
--- src/Actions/AtomsCalculation.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/AtomsCalculation.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,28 @@
+/*
+ * AtomsCalculation.hpp
+ *
+ *  Created on: Feb 19, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMSCALCULATION_HPP_
+#define ATOMSCALCULATION_HPP_
+
+#include "Actions/Calculation.hpp"
+
+template<typename T>
+class AtomsCalculation : public Calculation<std::vector<T> >
+{
+public:
+  AtomsCalculation(boost::function<T(atom*)> op,std::string name,AtomDescriptor descr);
+  virtual ~AtomsCalculation();
+
+protected:
+  virtual std::vector<T>* doCalc();
+
+private:
+  AtomDescriptor descr;
+  boost::function<T(atom*)> op;
+};
+
+#endif /* ATOMSCALCULATION_HPP_ */
Index: src/Actions/AtomsCalculation_impl.hpp
===================================================================
--- src/Actions/AtomsCalculation_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/AtomsCalculation_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,46 @@
+/*
+ * AtomsCalculation_impl.hpp
+ *
+ *  Created on: Feb 19, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMSCALCULATION_IMPL_HPP_
+#define ATOMSCALCULATION_IMPL_HPP_
+
+#include "Actions/AtomsCalculation.hpp"
+#include "Actions/Calculation_impl.hpp"
+
+#include <iostream>
+
+using namespace std;
+
+template<typename T>
+AtomsCalculation<T>::AtomsCalculation(boost::function<T(atom*)> _op,std::string name,AtomDescriptor _descr) :
+  Calculation<std::vector<T> >(0,name,false),
+  descr(_descr),
+  op(_op)
+{}
+
+template<typename T>
+AtomsCalculation<T>::~AtomsCalculation(){
+}
+
+template<typename T>
+std::vector<T>* AtomsCalculation<T>::doCalc(){
+  World* world = World::getPointer();
+  int steps = world->numAtoms();
+  std::vector<T> *res = new std::vector<T>();
+  res->reserve(steps);
+  Process::setMaxSteps(steps);
+  Process::start();
+  for(World::AtomIterator iter=world->getAtomIter(descr);iter!=world->atomEnd();++iter){
+    Process::setCurrStep(iter.getCount());
+    res->push_back(op(*iter));
+  }
+  Process::stop();
+  return res;
+}
+
+
+#endif /* ATOMSCALCULATION_IMPL_HPP_ */
Index: src/Actions/Calculation.hpp
===================================================================
--- src/Actions/Calculation.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/Calculation.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,73 @@
+/*
+ * Calculation.hpp
+ *
+ *  Created on: Feb 19, 2010
+ *      Author: crueger
+ */
+
+#ifndef CALCULATION_HPP_
+#define CALCULATION_HPP_
+
+#include "Actions/Process.hpp"
+
+/**
+ * A calculation is a Process that has some kind of result.
+ *
+ * This class can be used in the same way as any other Action or Process, but has some special methods
+ * for inspecting the result of the calculation.
+ */
+template<typename T>
+class Calculation : public Process
+{
+public:
+  Calculation(int _maxSteps, std::string _name, bool _doRegister=true);
+  virtual ~Calculation();
+
+  /**
+   * Reimplemented call method for Action Base class.
+   * Resets the result and then redoes the calculation. Can be used to retrigger calculations
+   * from menu Items or other places.
+   */
+  virtual bool canUndo();
+
+  virtual bool shouldUndo();
+
+  /**
+   * Does the actual calculation and returns the result.
+   * When the calculation has been done before it is not redone, but the previous cached result is returned.
+   * Call reset to delete the cached value.
+   */
+  virtual T operator()();
+
+  /**
+   * Check if a cached result is available.
+   */
+  virtual bool hasResult();
+
+  /**
+   * Get the cached result.
+   * Fails if there is no cached result.
+   */
+  virtual T getResult();
+
+  /**
+   * Delete a previously calculated result from the cache.
+   */
+  virtual void reset();
+
+protected:
+  T* result;
+
+  /**
+   * Pure virtual method for implementation of the actual calculation procedure.
+   */
+  virtual T* doCalc()=0;
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  bool done;
+};
+
+#endif /* CALCULATION_HPP_ */
Index: src/Actions/Calculation_impl.hpp
===================================================================
--- src/Actions/Calculation_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/Calculation_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,89 @@
+/*
+ * Calculation_impl.hpp
+ *
+ *  Created on: Feb 19, 2010
+ *      Author: crueger
+ */
+
+#ifndef CALCULATION_IMPL_HPP_
+#define CALCULATION_IMPL_HPP_
+
+#include "Actions/Calculation.hpp"
+
+#include <cassert>
+
+template<typename T>
+Calculation<T>::Calculation(int _maxSteps, std::string _name, bool _doRegister) :
+  Process(_maxSteps,_name,_doRegister),
+  result(0),
+  done(false)
+{}
+
+template<typename T>
+Calculation<T>::~Calculation()
+{
+  delete result;
+}
+
+// methods inherited from Action
+
+template<typename T>
+Action::state_ptr Calculation<T>::performCall(){
+  reset();
+  (*this)();
+  return Action::success;
+}
+
+template<typename T>
+Action::state_ptr Calculation<T>::performUndo(Action::state_ptr){
+  ASSERT(0,"Cannot undo a calculation");
+  return Action::success;
+}
+template<typename T>
+Action::state_ptr Calculation<T>::performRedo(Action::state_ptr){
+  ASSERT(0,"Cannot redo a calculation");
+  return Action::success;
+}
+
+template<typename T>
+bool Calculation<T>::canUndo()
+{
+  return false;
+}
+
+template<typename T>
+bool Calculation<T>::shouldUndo()
+{
+  return false;
+}
+
+// methods for calculation infrastructure
+
+template<typename T>
+T Calculation<T>::operator()(){
+  if(!done){
+    result = doCalc();
+    done = true;
+  }
+  return *result;
+}
+
+template<typename T>
+bool Calculation<T>::hasResult(){
+  return done;
+}
+
+template<typename T>
+T Calculation<T>::getResult(){
+  assert(done && "No result calculated");
+  return *result;
+}
+
+template<typename T>
+void Calculation<T>::reset(){
+  done = false;
+  delete result;
+  result = 0;
+}
+
+#endif /* CALCULATION_IMPL_HPP_ */
Index: src/Actions/CmdAction/HelpAction.cpp
===================================================================
--- src/Actions/CmdAction/HelpAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/CmdAction/HelpAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,68 @@
+/*
+ * HelpAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/HelpAction.hpp"
+#include "CommandLineParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+
+const char CommandLineHelpAction::NAME[] = "help";
+
+CommandLineHelpAction::CommandLineHelpAction() :
+  Action(NAME)
+{}
+
+CommandLineHelpAction::~CommandLineHelpAction()
+{}
+
+Action::state_ptr CommandLineHelpAction::performCall() {
+  ostringstream usage;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  usage << CommandLineParser::getInstance().visible << endl;
+  dialog->queryEmpty(NAME, usage.str());
+
+  if(dialog->display()) {
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineHelpAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineHelpAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineHelpAction::canUndo() {
+  return false;
+}
+
+bool CommandLineHelpAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineHelpAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/HelpAction.hpp
===================================================================
--- src/Actions/CmdAction/HelpAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/CmdAction/HelpAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,30 @@
+/*
+ * HelpAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef HELPACTION_HPP_
+#define HELPACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class CommandLineHelpAction : public Action {
+public:
+  CommandLineHelpAction();
+  virtual ~CommandLineHelpAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* HELPACTION_HPP_ */
Index: src/Actions/CmdAction/VersionAction.cpp
===================================================================
--- src/Actions/CmdAction/VersionAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/CmdAction/VersionAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,66 @@
+/*
+ * VersionAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/VersionAction.hpp"
+#include "CommandLineParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+
+const char CommandLineVersionAction::NAME[] = "version";
+
+CommandLineVersionAction::CommandLineVersionAction() :
+  Action(NAME)
+{}
+
+CommandLineVersionAction::~CommandLineVersionAction()
+{}
+
+Action::state_ptr CommandLineVersionAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryEmpty(NAME, ESPACKVersion);
+
+  if(dialog->display()) {
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineVersionAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineVersionAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineVersionAction::canUndo() {
+  return false;
+}
+
+bool CommandLineVersionAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineVersionAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/VersionAction.hpp
===================================================================
--- src/Actions/CmdAction/VersionAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/CmdAction/VersionAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,31 @@
+/*
+ * VersionAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef VERSIONACTION_HPP_
+#define VERSIONACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include "version.h"
+
+class CommandLineVersionAction : public Action {
+public:
+  CommandLineVersionAction();
+  virtual ~CommandLineVersionAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* VERSIONACTION_HPP_ */
Index: src/Actions/ErrorAction.cpp
===================================================================
--- src/Actions/ErrorAction.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/ErrorAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -11,4 +11,5 @@
 #include "log.hpp"
 #include "verbose.hpp"
+#include "Helpers/Assert.hpp"
 
 using namespace std;
@@ -24,8 +25,16 @@
 }
 
-void ErrorAction::call() {
+Action::state_ptr ErrorAction::performCall() {
   Log() << Verbose(0) << errorMsg << endl;
+  return Action::success;
 }
-void ErrorAction::undo() {
+Action::state_ptr ErrorAction::performUndo(Action::state_ptr) {
+  ASSERT(0,"Undo called for an ErrorAction");
+  return Action::success;
+}
+
+Action::state_ptr ErrorAction::performRedo(Action::state_ptr) {
+  ASSERT(0,"Redo called for an ErrorAction");
+  return Action::success;
 }
 
@@ -33,2 +42,6 @@
   return false;
 }
+
+bool ErrorAction::shouldUndo(){
+  return false;
+}
Index: src/Actions/ErrorAction.hpp
===================================================================
--- src/Actions/ErrorAction.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/ErrorAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -18,9 +18,13 @@
   virtual ~ErrorAction();
 
-  virtual void call();
-  virtual void undo();
   virtual bool canUndo();
+  virtual bool shouldUndo();
 
 private:
+
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
   std::string errorMsg;
 };
Index: src/Actions/MakroAction.cpp
===================================================================
--- src/Actions/MakroAction.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/MakroAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -11,6 +11,19 @@
 #include "Actions/Action.hpp"
 #include "Actions/ActionSequence.hpp"
+#include "Helpers/Assert.hpp"
 
 using namespace std;
+
+class MakroActionState : public ActionState{
+public:
+  MakroActionState(ActionSequence::stateSet _states) :
+    states(_states)
+  {}
+  virtual ~MakroActionState(){
+    // All contained states are destroyed by the shared ptrs
+  }
+
+  ActionSequence::stateSet states;
+};
 
 MakroAction::MakroAction(string _name,ActionSequence* _actions,bool _doRegister) :
@@ -23,5 +36,5 @@
 {
   Action* action;
-  while(action=actions->removeLastAction()){
+  while((action=actions->removeLastAction())){
     delete action;
   }
@@ -30,10 +43,21 @@
 
 
-void MakroAction::call(){
-  actions->callAll();
+Action::state_ptr MakroAction::performCall(){
+  ActionSequence::stateSet states = actions->callAll(true);
+  return Action::state_ptr(new MakroActionState(states));
 }
 
-void MakroAction::undo() {
-  actions->undoAll();
+Action::state_ptr MakroAction::performUndo(Action::state_ptr _state) {
+  MakroActionState *state = dynamic_cast<MakroActionState*>(_state.get());
+  ASSERT(state,"Type mismatch for the state of the MakroAction");
+  ActionSequence::stateSet states = actions->undoAll(state->states);
+  return Action::state_ptr(new MakroActionState(states));
+}
+
+Action::state_ptr MakroAction::performRedo(Action::state_ptr _state){
+  MakroActionState *state = dynamic_cast<MakroActionState*>(_state.get());
+  ASSERT(state,"Type mismatch for the state of the MakroAction");
+  ActionSequence::stateSet states = actions->redoAll(state->states);
+  return Action::state_ptr(new MakroActionState(states));
 }
 
@@ -41,2 +65,6 @@
   return actions->canUndo();
 }
+
+bool MakroAction::shouldUndo() {
+  return actions->shouldUndo();
+}
Index: src/Actions/MakroAction.hpp
===================================================================
--- src/Actions/MakroAction.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/MakroAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -26,9 +26,12 @@
   virtual ~MakroAction();
 
-  virtual void call();
-  virtual void undo();
-  virtual bool canUndo();
+  bool canUndo();
+  bool shouldUndo();
 
 private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
   ActionSequence *actions;
 };
Index: src/Actions/ManipulateAtomsProcess.cpp
===================================================================
--- src/Actions/ManipulateAtomsProcess.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ManipulateAtomsProcess.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,58 @@
+/*
+ * ManipulateAtomsProcess.cpp
+ *
+ *  Created on: Feb 18, 2010
+ *      Author: crueger
+ */
+
+#include "ManipulateAtomsProcess.hpp"
+
+#include <iostream>
+
+#include "World.hpp"
+#include "Helpers/Assert.hpp"
+
+using namespace std;
+
+ManipulateAtomsProcess::ManipulateAtomsProcess(boost::function<void(atom*)> _operation, AtomDescriptor _descr,
+                                               std::string _name,bool _doRegister) :
+  Process(0,_name,_doRegister),
+  descr(_descr),
+  operation(_operation)
+{}
+
+ManipulateAtomsProcess::~ManipulateAtomsProcess()
+{}
+
+Action::state_ptr ManipulateAtomsProcess::performCall(){
+  World::getInstance().doManipulate(this);
+  return Action::success;
+}
+
+Action::state_ptr ManipulateAtomsProcess::performUndo(Action::state_ptr){
+  ASSERT(0,"Undo called for a ManipulateAtomsProcess");
+  return Action::success;
+}
+
+Action::state_ptr ManipulateAtomsProcess::performRedo(Action::state_ptr){
+  ASSERT(0,"Redo called for a ManipulateAtomsProcess");
+  return Action::success;
+}
+
+bool ManipulateAtomsProcess::canUndo(){
+  return false;
+}
+
+bool ManipulateAtomsProcess::shouldUndo(){
+  return true;
+}
+
+void ManipulateAtomsProcess::doManipulate(World *world){
+  setMaxSteps(world->numAtoms());
+  start();
+  for(World::AtomIterator iter=world->getAtomIter(descr);iter!=world->atomEnd();++iter){
+    setCurrStep(iter.getCount());
+    operation(*iter);
+  }
+  stop();
+}
Index: src/Actions/ManipulateAtomsProcess.hpp
===================================================================
--- src/Actions/ManipulateAtomsProcess.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ManipulateAtomsProcess.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,39 @@
+/*
+ * ManipulateAtomsProcess.hpp
+ *
+ *  Created on: Feb 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef MANIPULATEATOMSPROCESS_HPP_
+#define MANIPULATEATOMSPROCESS_HPP_
+
+#include "Actions/Process.hpp"
+
+#include<boost/function.hpp>
+
+#include "Descriptors/AtomDescriptor.hpp"
+
+class World;
+
+class ManipulateAtomsProcess : public Process
+{
+public:
+  ManipulateAtomsProcess(boost::function<void(atom*)> _operation, AtomDescriptor descr,std::string _name,bool _doRegister=true);
+  virtual ~ManipulateAtomsProcess();
+
+  virtual bool canUndo();
+  virtual bool shouldUndo();
+
+  virtual void doManipulate(World *);
+private:
+
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  AtomDescriptor descr;
+  boost::function<void(atom*)> operation;
+};
+
+#endif /* MANIPULATEATOMSPROCESS_HPP_ */
Index: src/Actions/MethodAction.hpp
===================================================================
--- src/Actions/MethodAction.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/MethodAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -22,12 +22,14 @@
   MethodAction(std::string _name,boost::function<void()> _executeMethod,bool _doRegister=true);
   virtual ~MethodAction();
+  virtual bool canUndo();
+  virtual bool shouldUndo();
 
-  virtual void call();
-  virtual void undo();
-  virtual bool canUndo();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
 
   boost::function<void()> executeMethod; //!< this stores the method to be called
-
-
 };
 
Index: src/Actions/MoleculeAction/ChangeNameAction.cpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,87 @@
+/*
+ * ChangeNameAction.cpp
+ *
+ *  Created on: Jan 15, 2010
+ *      Author: crueger
+ */
+
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+
+#include "atom.hpp"
+#include "molecule.hpp"
+
+/****** MoleculeChangeNameAction *****/
+
+// memento to remember the state when undoing
+
+class MoleculeChangeNameState : public ActionState {
+public:
+  MoleculeChangeNameState(molecule* _mol,std::string _lastName) :
+    mol(_mol),
+    lastName(_lastName)
+  {}
+  molecule* mol;
+  std::string lastName;
+};
+
+const char MoleculeChangeNameAction::NAME[] = "Change filename of Molecule";
+
+MoleculeChangeNameAction::MoleculeChangeNameAction(MoleculeListClass *_molecules) :
+  Action(NAME),
+  molecules(_molecules)
+{}
+
+MoleculeChangeNameAction::~MoleculeChangeNameAction()
+{}
+
+Action::state_ptr MoleculeChangeNameAction::performCall() {
+  string filename;
+  molecule *mol = NULL;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryMolecule("Enter index of molecule: ",&mol,molecules);
+  dialog->queryString("Enter name: ",&filename);
+
+  if(dialog->display()) {
+    string oldName = mol->getName();
+    mol->setName(filename);
+    delete dialog;
+    return Action::state_ptr(new MoleculeChangeNameState(mol,oldName));
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeChangeNameAction::performUndo(Action::state_ptr _state) {
+  MoleculeChangeNameState *state = assert_cast<MoleculeChangeNameState*>(_state.get());
+
+  string newName = state->mol->getName();
+  state->mol->setName(state->lastName);
+
+  return Action::state_ptr(new MoleculeChangeNameState(state->mol,newName));
+}
+
+Action::state_ptr MoleculeChangeNameAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeChangeNameAction::canUndo() {
+  return true;
+}
+
+bool MoleculeChangeNameAction::shouldUndo() {
+  return true;
+}
+
+const string MoleculeChangeNameAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/ChangeNameAction.hpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,35 @@
+/*
+ * ChangeNameAction.hpp
+ *
+ *  Created on: Jan 15, 2010
+ *      Author: crueger
+ */
+
+#ifndef CHANGENAMEACTION_HPP
+#define CHANGENAMEACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeChangeNameAction : public Action {
+public:
+  MoleculeChangeNameAction(MoleculeListClass*);
+  virtual ~MoleculeChangeNameAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  MoleculeListClass *molecules;
+  static const char NAME[];
+};
+
+
+#endif // CHANGENAMEACTION_HPP
Index: src/Actions/ParserAction/LoadXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ParserAction/LoadXyzAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,88 @@
+/*
+ * LoadXyzAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/ParserAction/LoadXyzAction.hpp"
+#include "Parser/XyzParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+
+#include "atom.hpp"
+#include "molecule.hpp"
+
+/****** ParserLoadXyzAction *****/
+
+//// memento to remember the state when undoing
+//
+//class ParserLoadXyzState : public ActionState {
+//public:
+//  ParserLoadXyzState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char ParserLoadXyzAction::NAME[] = "LoadXyz";
+
+ParserLoadXyzAction::ParserLoadXyzAction() :
+  Action(NAME)
+{}
+
+ParserLoadXyzAction::~ParserLoadXyzAction()
+{}
+
+Action::state_ptr ParserLoadXyzAction::performCall() {
+  string filename;
+  XyzParser parser;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryString("filename",&filename, "Filename of the xyz file");
+
+  if(dialog->display()) {
+    // parse xyz file
+    ifstream input;
+    input.open(filename.c_str());
+    if (!input.fail())
+      parser.load(&input);
+    input.close();
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr ParserLoadXyzAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr ParserLoadXyzAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool ParserLoadXyzAction::canUndo() {
+  return false;
+}
+
+bool ParserLoadXyzAction::shouldUndo() {
+  return false;
+}
+
+const string ParserLoadXyzAction::getName() {
+  return NAME;
+}
Index: src/Actions/ParserAction/LoadXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ParserAction/LoadXyzAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,31 @@
+/*
+ * LoadXyzAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef LOADXYZACTION_HPP_
+#define LOADXYZACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class ParserLoadXyzAction : public Action {
+public:
+  ParserLoadXyzAction();
+  virtual ~ParserLoadXyzAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* LOADXYZACTION_HPP_ */
